From: "Darrick J. Wong" <djwong@kernel.org>
To: Chandan Babu R <chandanrlinux@gmail.com>
Cc: fstests@vger.kernel.org, linux-xfs@vger.kernel.org
Subject: Re: [PATCH V5 04/13] xfs: Check for extent overflow when trivally adding a new extent
Date: Mon, 8 Mar 2021 10:08:05 -0800 [thread overview]
Message-ID: <20210308180805.GR3419940@magnolia> (raw)
In-Reply-To: <20210308155111.53874-5-chandanrlinux@gmail.com>
On Mon, Mar 08, 2021 at 09:21:02PM +0530, Chandan Babu R wrote:
> This test verifies that XFS does not cause inode fork's extent count to
> overflow when adding a single extent while there's no possibility of splitting
> an existing mapping.
>
> Signed-off-by: Chandan Babu R <chandanrlinux@gmail.com>
Looks ok,
Reviewed-by: Darrick J. Wong <djwong@kernel.org>
--D
> ---
> tests/xfs/528 | 171 ++++++++++++++++++++++++++++++++++++++++++++++
> tests/xfs/528.out | 20 ++++++
> tests/xfs/group | 1 +
> 3 files changed, 192 insertions(+)
> create mode 100755 tests/xfs/528
> create mode 100644 tests/xfs/528.out
>
> diff --git a/tests/xfs/528 b/tests/xfs/528
> new file mode 100755
> index 00000000..5eb1021a
> --- /dev/null
> +++ b/tests/xfs/528
> @@ -0,0 +1,171 @@
> +#! /bin/bash
> +# SPDX-License-Identifier: GPL-2.0
> +# Copyright (c) 2021 Chandan Babu R. All Rights Reserved.
> +#
> +# FS QA Test 528
> +#
> +# Verify that XFS does not cause inode fork's extent count to overflow when
> +# adding a single extent while there's no possibility of splitting an existing
> +# mapping.
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1 # failure is the default!
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> + cd /
> + rm -f $tmp.*
> +}
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +. ./common/quota
> +. ./common/inject
> +. ./common/populate
> +
> +# remove previous $seqres.full before test
> +rm -f $seqres.full
> +
> +# real QA test starts here
> +
> +_supported_fs xfs
> +_require_scratch
> +_require_xfs_quota
> +_require_xfs_debug
> +_require_test_program "punch-alternating"
> +_require_xfs_io_command "falloc"
> +_require_xfs_io_error_injection "reduce_max_iextents"
> +_require_xfs_io_error_injection "bmap_alloc_minlen_extent"
> +
> +echo "Format and mount fs"
> +_scratch_mkfs_sized $((512 * 1024 * 1024)) >> $seqres.full
> +_scratch_mount -o uquota >> $seqres.full
> +
> +bsize=$(_get_file_block_size $SCRATCH_MNT)
> +
> +echo "* Delalloc to written extent conversion"
> +
> +testfile=$SCRATCH_MNT/testfile
> +
> +echo "Inject reduce_max_iextents error tag"
> +_scratch_inject_error reduce_max_iextents 1
> +
> +nr_blks=$((15 * 2))
> +
> +echo "Create fragmented file"
> +for i in $(seq 0 2 $((nr_blks - 1))); do
> + $XFS_IO_PROG -f -s -c "pwrite $((i * bsize)) $bsize" $testfile \
> + >> $seqres.full 2>&1
> + [[ $? != 0 ]] && break
> +done
> +
> +echo "Verify \$testfile's extent count"
> +
> +nextents=$(xfs_get_fsxattr nextents $testfile)
> +if (( $nextents > 10 )); then
> + echo "Extent count overflow check failed: nextents = $nextents"
> + exit 1
> +fi
> +
> +rm $testfile
> +
> +echo "* Fallocate unwritten extents"
> +
> +echo "Fallocate fragmented file"
> +for i in $(seq 0 2 $((nr_blks - 1))); do
> + $XFS_IO_PROG -f -c "falloc $((i * bsize)) $bsize" $testfile \
> + >> $seqres.full 2>&1
> + [[ $? != 0 ]] && break
> +done
> +
> +echo "Verify \$testfile's extent count"
> +
> +nextents=$(xfs_get_fsxattr nextents $testfile)
> +if (( $nextents > 10 )); then
> + echo "Extent count overflow check failed: nextents = $nextents"
> + exit 1
> +fi
> +
> +rm $testfile
> +
> +echo "* Directio write"
> +
> +echo "Create fragmented file via directio writes"
> +for i in $(seq 0 2 $((nr_blks - 1))); do
> + $XFS_IO_PROG -d -s -f -c "pwrite $((i * bsize)) $bsize" $testfile \
> + >> $seqres.full 2>&1
> + [[ $? != 0 ]] && break
> +done
> +
> +echo "Verify \$testfile's extent count"
> +
> +nextents=$(xfs_get_fsxattr nextents $testfile)
> +if (( $nextents > 10 )); then
> + echo "Extent count overflow check failed: nextents = $nextents"
> + exit 1
> +fi
> +
> +rm $testfile
> +
> +# Check if XFS gracefully returns with an error code when we try to increase
> +# extent count of user quota inode beyond the pseudo max extent count limit.
> +echo "* Extend quota inodes"
> +
> +echo "Disable reduce_max_iextents error tag"
> +_scratch_inject_error reduce_max_iextents 0
> +
> +echo "Consume free space"
> +fillerdir=$SCRATCH_MNT/fillerdir
> +nr_free_blks=$(stat -f -c '%f' $SCRATCH_MNT)
> +nr_free_blks=$((nr_free_blks * 90 / 100))
> +
> +_fill_fs $((bsize * nr_free_blks)) $fillerdir $bsize 0 >> $seqres.full 2>&1
> +
> +echo "Create fragmented filesystem"
> +for dentry in $(ls -1 $fillerdir/); do
> + $here/src/punch-alternating $fillerdir/$dentry >> $seqres.full
> +done
> +
> +echo "Inject reduce_max_iextents error tag"
> +_scratch_inject_error reduce_max_iextents 1
> +
> +echo "Inject bmap_alloc_minlen_extent error tag"
> +_scratch_inject_error bmap_alloc_minlen_extent 1
> +
> +nr_blks=20
> +
> +# This is a rough calculation; It doesn't take block headers into
> +# consideration.
> +# gdb -batch vmlinux -ex 'print sizeof(struct xfs_dqblk)'
> +# $1 = 136
> +nr_quotas_per_block=$((bsize / 136))
> +nr_quotas=$((nr_quotas_per_block * nr_blks))
> +
> +echo "Extend uquota file"
> +for i in $(seq 0 $nr_quotas_per_block $nr_quotas); do
> + chown $i $testfile >> $seqres.full 2>&1
> + [[ $? != 0 ]] && break
> +done
> +
> +_scratch_unmount >> $seqres.full
> +
> +echo "Verify uquota inode's extent count"
> +uquotino=$(_scratch_xfs_get_metadata_field 'uquotino' 'sb 0')
> +
> +nextents=$(_scratch_get_iext_count $uquotino data || \
> + _fail "Unable to obtain inode fork's extent count")
> +if (( $nextents > 10 )); then
> + echo "Extent count overflow check failed: nextents = $nextents"
> + exit 1
> +fi
> +
> +# success, all done
> +status=0
> +exit
> diff --git a/tests/xfs/528.out b/tests/xfs/528.out
> new file mode 100644
> index 00000000..3973cc15
> --- /dev/null
> +++ b/tests/xfs/528.out
> @@ -0,0 +1,20 @@
> +QA output created by 528
> +Format and mount fs
> +* Delalloc to written extent conversion
> +Inject reduce_max_iextents error tag
> +Create fragmented file
> +Verify $testfile's extent count
> +* Fallocate unwritten extents
> +Fallocate fragmented file
> +Verify $testfile's extent count
> +* Directio write
> +Create fragmented file via directio writes
> +Verify $testfile's extent count
> +* Extend quota inodes
> +Disable reduce_max_iextents error tag
> +Consume free space
> +Create fragmented filesystem
> +Inject reduce_max_iextents error tag
> +Inject bmap_alloc_minlen_extent error tag
> +Extend uquota file
> +Verify uquota inode's extent count
> diff --git a/tests/xfs/group b/tests/xfs/group
> index e861cec9..2356c4a9 100644
> --- a/tests/xfs/group
> +++ b/tests/xfs/group
> @@ -525,3 +525,4 @@
> 525 auto quick mkfs
> 526 auto quick mkfs
> 527 auto quick quota
> +528 auto quick quota
> --
> 2.29.2
>
next prev parent reply other threads:[~2021-03-08 18:08 UTC|newest]
Thread overview: 23+ messages / expand[flat|nested] mbox.gz Atom feed top
2021-03-08 15:50 [PATCH V5 00/13] xfs: Tests to verify inode fork extent count overflow detection Chandan Babu R
2021-03-08 15:50 ` [PATCH V5 01/13] _check_xfs_filesystem: sync fs before running scrub Chandan Babu R
2021-03-08 17:50 ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 02/13] common/xfs: Add a helper to get an inode fork's extent count Chandan Babu R
2021-03-08 17:52 ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 03/13] common/xfs: Add helper to obtain fsxattr field value Chandan Babu R
2021-03-08 17:53 ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 04/13] xfs: Check for extent overflow when trivally adding a new extent Chandan Babu R
2021-03-08 18:08 ` Darrick J. Wong [this message]
2021-03-08 15:51 ` [PATCH V5 05/13] xfs: Check for extent overflow when growing realtime bitmap/summary inodes Chandan Babu R
2021-03-08 18:10 ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 06/13] xfs: Check for extent overflow when punching a hole Chandan Babu R
2021-03-08 15:51 ` [PATCH V5 07/13] xfs: Check for extent overflow when adding/removing xattrs Chandan Babu R
2021-03-08 15:51 ` [PATCH V5 08/13] xfs: Check for extent overflow when adding/removing dir entries Chandan Babu R
2021-03-08 18:15 ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 09/13] xfs: Check for extent overflow when writing to unwritten extent Chandan Babu R
2021-03-08 18:16 ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 10/13] xfs: Check for extent overflow when moving extent from cow to data fork Chandan Babu R
2021-03-08 18:18 ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 11/13] xfs: Check for extent overflow when remapping an extent Chandan Babu R
2021-03-08 18:19 ` Darrick J. Wong
2021-03-08 15:51 ` [PATCH V5 12/13] xfs: Check for extent overflow when swapping extents Chandan Babu R
2021-03-08 15:51 ` [PATCH V5 13/13] xfs: Stress test with bmap_alloc_minlen_extent error tag enabled Chandan Babu R
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20210308180805.GR3419940@magnolia \
--to=djwong@kernel.org \
--cc=chandanrlinux@gmail.com \
--cc=fstests@vger.kernel.org \
--cc=linux-xfs@vger.kernel.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox